<?php
class ControllerExtensionModuleItvmOrders extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/itvm_orders');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('extension/module/itvm_orders');
		$this->load->model('setting/setting');

		// Сохранение настроек модуля, когда пользователь нажал "Записать"
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			// Вызываем метод "модели" для сохранения настроек
			$this->model_setting_setting->editSetting('itvm_orders', $this->request->post);
			// Выходим из настроек с выводом сообщения
			$this->session->data['success'] = $this->language->get('text_success');
			$createApiKey = $this->model_extension_module_itvm_orders->createApiKey();
		}

		$data = array();

		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_extension'] = $this->language->get('text_extension');
		$data['text_success'] = $this->language->get('text_success');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['error_permission'] = $this->language->get('error_permission');
		$data['text_develop'] = $this->language->get('text_develop');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		// Загружаем настройки через метод "модели"

		$data['breadcrumbs'] = array();
	    $data['breadcrumbs'][] = array(
	      'text' => $this->language->get('text_home'),
	      'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
	    );
	    $data['breadcrumbs'][] = array(
	      'text' => $this->language->get('text_extension'),
	      'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
	    );
	    $data['breadcrumbs'][] = array(
	      'text' => $this->language->get('heading_title'),
	      'href' => $this->url->link('extension/module/itvm_orders', 'token=' . $this->session->data['token'], true)
	    );
	    
	    $getApiKey = $this->model_extension_module_itvm_orders->getApiKey();
	    if ($getApiKey) {
		    $data['api_key_itvm_orders'] = $getApiKey;
	    }
	 	
	    // Кнопки действий
	    $data['action'] = $this->url->link('extension/module/itvm_orders', 'token=' . $this->session->data['token'], true);
	    $data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

	    if (isset($this->request->post['itvm_orders_status'])) {
			$data['itvm_orders_status'] = $this->request->post['itvm_orders_status'];
		} else {
			$data['itvm_orders_status'] = $this->config->get('itvm_orders_status');
		}

		$data['link_to_start'] = HTTP_CATALOG . 'index.php?route=extension/module/itvm_orders';

	    // Загрузка шаблонов для шапки, колонки слева и футера
	    $data['header'] = $this->load->controller('common/header');
	    $data['column_left'] = $this->load->controller('common/column_left');
	    $data['footer'] = $this->load->controller('common/footer');
	 
	    // Выводим в браузер шаблон
	    $this->response->setOutput($this->load->view('extension/module/itvm_orders', $data));

	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/itvm_orders')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

}