<?php
class ControllerExtensionModuleItvmOrders extends Controller {

	public function index() {
		$this->load->model('extension/module/itvm_orders');

		$postData = file_get_contents('php://input');
		$data_from_json = json_decode(trim($postData), true);
		if (isset($data_from_json['key'])) {
			$key = $data_from_json['key'];
		} else {
			return;
		}

		$key_check = $this->model_extension_module_itvm_orders->checkKeyOrdersImportITVM($key);
		if (!$key_check) {
			return false;
		}

		if (isset($data_from_json['products_url']) && isset($data_from_json['load_image'])) {
			if (!$data_from_json['load_image']) {
				$this->model_extension_module_itvm_orders->loadProducts($data_from_json['products_url']);
			} else {
				$this->model_extension_module_itvm_orders->loadProductsImage($data_from_json['products_url']);
			}
			exit();
		}

		if (isset($data_from_json['date_from'])) {
			$date_from = date('Y-m-d 00:00:00', strtotime($data_from_json['date_from']));
		} else {
			$date_from = date('Y-m-d 00:00:00');
		}

		if (isset($data_from_json['date_to'])) {
			$date_to = date('Y-m-d 23:59:59', strtotime($data_from_json['date_to']));
		} else {
			$date_to = date('Y-m-d 23:59:59');
		}

		$filter = array(
			'date_from'	=> $date_from,
			'date_to'	=> $date_to
		);

		$itvm_orders = $this->model_extension_module_itvm_orders->getOrdersInfoITVM($filter);

		$response = json_encode($itvm_orders);
		echo $response;
	}

}