<?php

class ModelExtensionModuleItvmOrders extends Model {
	public function getOrdersInfoITVM($data) {
		$sql = "SELECT * FROM " . DB_PREFIX . "order o LEFT JOIN " . DB_PREFIX . "order_option oo ON (o.order_id = oo.order_id) LEFT JOIN " . DB_PREFIX . "order_status os ON (o.order_status_id = os.order_status_id) LEFT JOIN " . DB_PREFIX . "order_total ot ON (o.order_id = ot.order_id) WHERE o.date_added BETWEEN '".$data['date_from']."' AND '".$data['date_to']."' AND os.language_id = '" . (int)$this->config->get('config_language_id') . "'  AND ot.code='total'";
		$query = $this->db->query($sql)->rows;
		foreach ($query as $key => $result) {
			$query[$key]['items'] = $this->getInfoForProductITVM($result['order_id']);
			$total_price = 0;
			foreach ($query[$key]['items'] as $value) {
				$total_price = $total_price + ((float)$value['product_price'] * (int)$value['product_qty']);
			}
			$query[$key]['shipping'] = (float)$result['value'] - $total_price;
			$query[$key]['shipping'] = number_format($query[$key]['shipping'], 4, '.', '');
		}
		return $query;
	}

	public function checkKeyOrdersImportITVM($key) {
		$sql = "SELECT COUNT(*) as cnt FROM ".DB_PREFIX."api WHERE name='itvm_orders' AND `key`='".$key."'";
		
		$query = $this->db->query($sql)->row['cnt'];

		if ($query == 0) {
			return false;
		} else {
			return true;
		}
	}

	public function getInfoForProductITVM($order_id) {
		$sql = "SELECT product_id, quantity FROM ".DB_PREFIX."order_product WHERE order_id = '".$order_id."'";

		$query_products = $this->db->query($sql)->rows;

		$product_info = array();
		foreach ($query_products as $product) {
			$sql = "SELECT p.product_id, pd.name, p.price, p.sku FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) WHERE p.product_id = '" . (int)$product['product_id'] . "' AND pd.language_id = '" . (int)$this->config->get('config_language_id') . "'";
			$query = $this->db->query($sql)->rows;
		
			foreach ($query as $key => $value) {
				$product_info[] = array(
					'product_id'	=> $value['product_id'],
					'product_name'	=> $value['name'],
					'product_qty'	=> $product['quantity'],
					'product_price'	=> $value['price'],
					'product_sku'	=> $value['sku']
				);
			}
		}		

		return $product_info;
	}

	public function loadProducts($products_url) {
		$xml = simplexml_load_file($products_url);
		$categories = $xml->shop->categories[0];

		$list_categories = $this->createCategoryArray($categories);
		foreach ($list_categories as $tradeCRM_cat_id => $tradeCRM_cat) {
			$category_id = $this->getCategoryIdByName($tradeCRM_cat['name']);

			if (!$category_id) {
				$this->addCategoryFromTradeCRM($tradeCRM_cat['name'], $tradeCRM_cat['parentId'], $tradeCRM_cat['level'], $list_categories);
			} else {
				$this->editCategoryFromTradeCRM($tradeCRM_cat['name'], $tradeCRM_cat['parentId'], $tradeCRM_cat['level'], $list_categories, $category_id);
			}
		}

		$products = $xml->shop->offers[0];

		$counter = 0;
		foreach ($products as $key => $product) {
			$product_name = $product->name->__toString();
			$product_desc = $product->description->__toString();
			$product_vendorCode = $product->vendorCode->__toString();
			
			$category_prod_id = (int)$product->categoryId->__toString();

			$category_id = $this->getCategoryIdByName($list_categories[$category_prod_id]['name']);
			
			if ($category_id) {
				$product_id = $this->getProductIdBySku($product_vendorCode);
				if (!$product_id) {
					$product_id = $this->addProductFromTradeCRM($product, $category_id);
				} else {
					$this->editProductFromTradeCRM($product, $product_id, $category_id);
				}
				$counter++;
			}
		}
		$answer = $counter;

		$response = json_encode($answer);
		echo $response;
	}

	public function addProductFromTradeCRM($product, $category_id) {
		$model = $product->name->__toString();
		$sku = $product->vendorCode->__toString();
		$quantity = (int)$product->stock_quantity->__toString();
		$price = (float)$product->price->__toString();

		if ($quantity > 0) {
			$stock_status_id = $this->getStockStatusIDByName("В наличии");
		} else {
			$stock_status_id = $this->getStockStatusIDByName("Нет в наличии");
		}

		$sql = "INSERT INTO ".DB_PREFIX."product SET model = '".$this->db->escape($model)."', sku = '".$sku."', upc = '', ean = '', jan = '', isbn = '', mpn = '', location = '', quantity = '".$quantity."', minimum = '1', subtract = '0', stock_status_id = '".$stock_status_id."', date_available = '0000-00-00', manufacturer_id = '0',  price = '".$price."', points = '0', weight = '0', weight_class_id = '0', length = '0', width = '0', height = '0', length_class_id = '0', status = '1', tax_class_id = '0', sort_order = '0', date_added = NOW(), date_modified = NOW()";

		$this->db->query($sql);

		$product_id = $this->db->getLastId();

		$language_id = $this->getLanguageId();
		$description = htmlentities($product->description->__toString());

		$sql = "INSERT INTO ".DB_PREFIX."product_description SET product_id = '".(int)$product_id."', language_id = '".(int)$language_id."', name = '".$this->db->escape($model)."', description = '".$this->db->escape($description)."', tag = '', meta_title = '', meta_description = '', meta_keyword = ''";
		$this->db->query($sql);

		$category_ids = $this->getListCategoryByCategoryID($category_id);
		foreach ($category_ids as $cid) {
			if ($category_id == $cid) {
				$sql = "INSERT INTO ".DB_PREFIX."product_to_category SET product_id = '".(int)$product_id."', category_id = '".(int)$cid."', main_category = '1'";
			} else {
				$sql = "INSERT INTO ".DB_PREFIX."product_to_category SET product_id = '".(int)$product_id."', category_id = '".(int)$cid."', main_category = '0'";
			}
			$this->db->query($sql);
		}

		$sql = "INSERT INTO ".DB_PREFIX."product_to_store SET product_id = '".(int)$product_id."', store_id = '0'";
		$this->db->query($sql);
	}

	public function getLanguageId() {
		$sql = "SELECT * FROM ".DB_PREFIX."language WHERE code LIKE '%ru%'";

		$query = $this->db->query($sql);

		return (int)$query->row['language_id'];
	}

	public function editProductFromTradeCRM($product, $product_id, $category_id) {
		$model = $product->name->__toString();
		$sku = $product->vendorCode->__toString();
		$quantity = (int)$product->stock_quantity->__toString();
		$price = (float)$product->price->__toString();

		if ($quantity > 0) {
			$stock_status_id = $this->getStockStatusIDByName("В наличии");
		} else {
			$stock_status_id = $this->getStockStatusIDByName("Нет в наличии");
		}

		$sql = "UPDATE ".DB_PREFIX."product SET model = '".$this->db->escape($model)."', sku = '".$sku."', upc = '', ean = '', jan = '', isbn = '', mpn = '', location = '', quantity = '".$quantity."', minimum = '1', subtract = '0', stock_status_id = '".$stock_status_id."', date_available = '0000-00-00', manufacturer_id = '0',  price = '".$price."', points = '0', weight = '0', weight_class_id = '0', length = '0', width = '0', height = '0', length_class_id = '0', status = '1', tax_class_id = '0', sort_order = '0', date_added = NOW(), date_modified = NOW() WHERE product_id = '".(int)$product_id."'";

		$this->db->query($sql);

		$language_id = $this->getLanguageId();
		$description = $product->description->__toString();

		$sql = "UPDATE ".DB_PREFIX."product_description SET name = '".$this->db->escape($model)."', description = '".$this->db->escape($description)."' WHERE product_id = '".(int)$product_id."' AND language_id = '".(int)$language_id."', tag = ''";

		$sql = "DELETE FROM ".DB_PREFIX."product_to_category WHERE product_id = '".(int)$product_id."'";
		$this->db->query($sql);

		$category_ids = $this->getListCategoryByCategoryID($category_id);
		foreach ($category_ids as $cid) {
			if ($category_id == $cid){
				$sql = "INSERT INTO ".DB_PREFIX."product_to_category SET product_id = '".(int)$product_id."', category_id = '".(int)$cid."', main_category = '1'";
			} else {
				$sql = "INSERT INTO ".DB_PREFIX."product_to_category SET product_id = '".(int)$product_id."', category_id = '".(int)$cid."', main_category = '0'";
			}
			$this->db->query($sql);
		}

		$sql = "DELETE FROM ".DB_PREFIX."product_to_store WHERE product_id = '".(int)$product_id."'";
		$this->db->query($sql);

		$sql = "INSERT INTO ".DB_PREFIX."product_to_store SET product_id = '".(int)$product_id."', store_id = '0'";
		$this->db->query($sql);
	}

	public function getListCategoryByCategoryID($category_id) {
		$parent_id = $category_id;
		while ( $parent_id != 0 ) {
			$listParentID[] = $parent_id;
			$parent_id = $this->db->query("SELECT parent_id FROM " . DB_PREFIX . "category WHERE category_id = '" . (int)$parent_id . "'")->rows;
			$parent_id = $parent_id[0]['parent_id'];
		}
		return $listParentID;
	}

	public function loadProductsImage($products_url) {
		$xml = simplexml_load_file($products_url);
		
		$products = $xml->shop->offers[0];
		$counter = 0;
		foreach ($products as $key => $product) {
			$product_name = $product->name->__toString();
			$product_vendorCode = $product->vendorCode->__toString();

			$pict_arr = array();
			foreach ($product->picture as $key => $pict) {
				$pict_arr[] = $pict->__toString();
				$counter++;
			}

			$product_id = $this->getProductIdBySku($product_vendorCode);

			$this->addProductImage($pict_arr, $product_id, $product_name);
		}

		$answer = $counter;

		$response = json_encode($answer);
		echo $response;
	}

	public function addProductImage($pict_arr, $product_id, $product_name) {
		$first_image = true;
		$sql = "DELETE FROM ".DB_PREFIX."product_image WHERE product_id = '".(int)$product_id."'";
		$this->db->query($sql);

		foreach($pict_arr as $url) {
			$ch = curl_init($url); // инициализация
			$path_parts = pathinfo($url); //получаем название файла из URL
			// сохраняем полученный файл с его оригинальным названием
 			$path_img = 'catalog/demo/product/'.$path_parts['basename'];
			$fp = fopen(DIR_IMAGE.$path_img, 'wb');
			curl_setopt($ch, CURLOPT_FILE, $fp);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_exec($ch);
			curl_close($ch);
			fclose($fp);

			if ($first_image) {
				$sql = "UPDATE " . DB_PREFIX . "product SET image = '".$path_img."' WHERE product_id = '".(int)$product_id."'";
				$this->db->query($sql);
				$first_image = false;
			} else {
				$sql = "INSERT INTO ".DB_PREFIX."product_image SET product_id = '".(int)$product_id."', image = '".$path_img."', sort_order = '0'";
				$this->db->query($sql);
			}
		}
	}

	public function getStockStatusIDByName($status_name) {
		$sql = "SELECT stock_status_id FROM ".DB_PREFIX."stock_status WHERE name = '".$status_name."'";

		$query = $this->db->query($sql);
		if ($query->num_rows > 0) {
			return (int)$query->row['stock_status_id'];
		} else {
			return 0;
		}
	}

	public function createCategoryArray($categories) {
		$list_categories = array();
		$categories_with_parent = array();
		foreach ($categories as $category) {
			if (!$this->xml_attribute($category, 'parentId')) {
				$list_categories[$this->xml_attribute($category, 'id')] = array(
					'parentId'	=> 0,
					'name'		=> $category->__toString(),
					'level'		=> 0
				);
			} else {
				$categories_with_parent[] = array(
					'id'		=> $this->xml_attribute($category, 'id'),
					'parentId'	=> $this->xml_attribute($category, 'parentId'),
					'name'		=> $category->__toString()
				);
			}
		}

		$level = 1;
		while (count($categories_with_parent) > 0) {
			foreach ($categories_with_parent as $key => $category) {
				if (isset($list_categories[$category['parentId']])) {
					$list_categories[$category['id']] = array(
						'parentId'	=> $category['parentId'],
						'name'		=> $category['name'],
						'level'		=> $level
					);
					unset($categories_with_parent[$key]);
				}
			}
			$level++;
		}
		return $list_categories;
	}

	public function getCategoryIdByName($category_name) {
		$sql = "SELECT category_id FROM " . DB_PREFIX . "category_description WHERE name = '" . $category_name . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'";

		$query = $this->db->query($sql);
		if ($query->num_rows > 0) {
			return (int)$query->row['category_id'];
		} else {
			return false;
		}
	}

	public function addCategoryFromTradeCRM($category_name, $parent_id, $category_level, $list_categories) {
		if ($parent_id == 0) {
			$top = 1;
		} else {
			$parent_id = $this->getCategoryIdByName($list_categories[$parent_id]['name']);
			$top = 0;
		}
		$sql = "INSERT INTO " . DB_PREFIX . "category SET parent_id = '" . (int)$parent_id . "', top = '" . $top ."', status = '1', date_added = NOW(), date_modified = NOW()";
		$this->db->query($sql);

		$category_id = $this->db->getLastId(); 

		$sql = "INSERT INTO " . DB_PREFIX . "category_description SET category_id = '" . $category_id . "', language_id = '" . (int)$this->config->get('config_language_id') . "', name = '" . $this->db->escape($category_name) . "', meta_title = '" . $this->db->escape($category_name) . "'";
		$this->db->query($sql);

		$level = 0;

		$sql = "SELECT * FROM " . DB_PREFIX . "category_path WHERE category_id = '" . (int)$parent_id . "' ORDER BY level ASC";
		$query = $this->db->query($sql);

		foreach ($query->rows as $result) {
			$sql = "INSERT INTO " . DB_PREFIX . "category_path SET category_id = '" . (int)$category_id . "', path_id = '" . (int)$result['path_id'] . "', level = '" . (int)$level . "'";
			$this->db->query($sql);

			$level++;
		}

		$sql = "INSERT INTO " . DB_PREFIX . "category_path SET category_id = '" . (int)$category_id . "', path_id = '" . (int)$category_id . "', level = '" . (int)$level . "'";
		$this->db->query($sql);

		$store_id = 0;
		$sql = "INSERT INTO " . DB_PREFIX . "category_to_store SET category_id = '" . (int)$category_id . "', store_id = '" . $store_id ."'";
		$this->db->query($sql);
	}

	public function editCategoryFromTradeCRM($category_name, $parent_id, $category_level, $list_categories, $category_id) {
		if ($parent_id == 0) {
			$top = 1;
		} else {
			$parent_id = $this->getCategoryIdByName($list_categories[$parent_id]['name']);
			$top = 0;
		}
		$sql = "UPDATE " . DB_PREFIX . "category SET parent_id = '" . (int)$parent_id . "', top = '" . $top ."', status = '1', date_added = NOW(), date_modified = NOW() WHERE category_id = '".(int)$category_id."'";
		$this->db->query($sql);

		$language_id = $this->getLanguageId();
		$sql = "UPDATE " . DB_PREFIX . "category_description SET name = '" . $this->db->escape($category_name) . "', meta_title = '" . $this->db->escape($category_name) . "' WHERE category_id = '" . $category_id . "' AND language_id = '" . (int)$language_id . "'";
		$this->db->query($sql);

		$level = 0;

		$this->db->query("DELETE FROM ".DB_PREFIX."category_path WHERE category_id = '".(int)$category_id."'");

		$sql = "SELECT * FROM " . DB_PREFIX . "category_path WHERE category_id = '" . (int)$parent_id . "' ORDER BY level ASC";
		$query = $this->db->query($sql);

		foreach ($query->rows as $result) {
			$sql = "INSERT INTO " . DB_PREFIX . "category_path SET category_id = '" . (int)$category_id . "', path_id = '" . (int)$result['path_id'] . "', level = '" . (int)$level . "'";
			$this->db->query($sql);

			$level++;
		}

		$sql = "INSERT INTO " . DB_PREFIX . "category_path SET category_id = '" . (int)$category_id . "', path_id = '" . (int)$category_id . "', level = '" . (int)$level . "'";
		$this->db->query($sql);

		$this->db->query("DELETE FROM ".DB_PREFIX."category_to_store WHERE category_id = '".(int)$category_id."'");
		$store_id = 0;
		$sql = "INSERT INTO " . DB_PREFIX . "category_to_store SET category_id = '" . (int)$category_id . "', store_id = '" . $store_id ."'";
		$this->db->query($sql);
	}

	public function xml_attribute($object, $attribute) {
	    if (isset($object[$attribute])) {
	        return (string) $object[$attribute];
	    } else {
	    	return false;
	    }
	}

	public function getProductIdBySku($product_sku) {
		$sql = "SELECT product_id FROM ".DB_PREFIX."product WHERE sku = '".$product_sku."'";

		$query = $this->db->query($sql);

		if ($query->num_rows > 0) {
			return (int)$query->row['product_id'];
		} else {
			return false;
		}
	}

	//Traslitaration
	public function rus2translit($string) {
	    $converter = array(
	        'а' => 'a',   'б' => 'b',   'в' => 'v',
	        'г' => 'g',   'д' => 'd',   'е' => 'e',
	        'ё' => 'e',   'ж' => 'zh',  'з' => 'z',
	        'и' => 'i',   'й' => 'y',   'к' => 'k',
	        'л' => 'l',   'м' => 'm',   'н' => 'n',
	        'о' => 'o',   'п' => 'p',   'р' => 'r',
	        'с' => 's',   'т' => 't',   'у' => 'u',
	        'ф' => 'f',   'х' => 'h',   'ц' => 'c',
	        'ч' => 'ch',  'ш' => 'sh',  'щ' => 'sch',
	        'ь' => '\'',  'ы' => 'y',   'ъ' => '\'',
	        'э' => 'e',   'ю' => 'yu',  'я' => 'ya',
	        'ґ' => 'g',   'є' => 'ye',   'і' => 'i',
	        'ї' => 'yi',
	        
	        'А' => 'A',   'Б' => 'B',   'В' => 'V',
	        'Г' => 'G',   'Д' => 'D',   'Е' => 'E',
	        'Ё' => 'E',   'Ж' => 'Zh',  'З' => 'Z',
	        'И' => 'I',   'Й' => 'Y',   'К' => 'K',
	        'Л' => 'L',   'М' => 'M',   'Н' => 'N',
	        'О' => 'O',   'П' => 'P',   'Р' => 'R',
	        'С' => 'S',   'Т' => 'T',   'У' => 'U',
	        'Ф' => 'F',   'Х' => 'H',   'Ц' => 'C',
	        'Ч' => 'Ch',  'Ш' => 'Sh',  'Щ' => 'Sch',
	        'Ь' => '\'',  'Ы' => 'Y',   'Ъ' => '\'',
	        'Э' => 'E',   'Ю' => 'Yu',  'Я' => 'Ya',
	        'Ґ' => 'G',   'Є' => 'Ye',   'І' => 'I',
	        'Ї' => 'Yi'
	    );
	    return strtr($string, $converter);
	}
	public function strRus2url($keyword) {
	    // переводим в транслит
	    $keyword = rus2translit($keyword);
	    // в нижний регистр
	    $keyword = strtolower($keyword);
	    // заменям все ненужное нам на "-"
	    $keyword = preg_replace('~[^-a-z0-9_]+~u', '-', $keyword);
	    // удаляем начальные и конечные '-'
	    $keyword = trim($keyword, "-");
	    return $keyword;
	}
	//END Translitaration
}